
%global tarname spice

Name:           spice-server
Version:        0.12.0
Release:        12%{?dist}.3
Summary:        Implements the server side of the SPICE protocol
Group:          System Environment/Libraries
License:        LGPLv2+
URL:            http://www.spice-space.org/
Source0:        http://spice-space.org/download/releases/%{tarname}-%{version}.tar.bz2
Source100:      pyparsing.py

Patch1: 0001-reds-Abort-on-BN-new-failures.patch
Patch2: 0002-reds_init_net-report-errors-on-watch-setup-failures.patch
Patch3: 0003-reds-report-SSL-initialization-errors.patch
Patch4: 0004-reds-Check-reds_init_ssl-errors.patch
Patch5: 0005-reds-Report-errors-from-load_dh_params.patch
Patch6: 0006-reds-Check-errors-returned-from-SSL_CTX_set_cipher_l.patch
Patch7: 0007-reds-Report-an-error-when-reds_char_device_add_state.patch
Patch8: 0008-server-red_worker-don-t-call-set_client_capabilities.patch
Patch9: 0009-display-seamless-migration-don-t-process-both-cmd-ri.patch
Patch10: 0010-display-seamless-migration-no-need-to-trace-the-gene.patch
Patch11: 0011-char_device.c-fix-call-to-spice_marshaller_add_ref-w.patch
Patch12: 0012-char_device.c-add-ref-count-for-write-to-device-buff.patch
Patch13: 0013-char_device.c-when-the-state-is-destroyed-also-free-.patch
Patch14: 0014-reds.c-fix-calls-to-spice_marshaller_add_ref-with-pt.patch
Patch15: 0015-red_worker.c-fix-marshalling-of-migration-data.patch
Patch16: 0016-smartcard.c-avoid-marshalling-migration-data-with-re.patch
Patch17: 0017-red_worker.c-fix-not-sending-all-pending-messages-wh.patch
Patch18: 0018-red_worker.c-fix-memory-corruption-when-data-from-cl.patch
Patch19: 0019-red_worker-fix-sending-internal-images-with-stride-b.patch
Patch20: 0020-red_worker-no-need-to-align-the-stride-of-internal-i.patch
Patch21: 0021-agent-fix-mishandling-of-agent-data-received-from-th.patch
Patch22: 0022-red_worker-revert-upstream-8855438a.patch
Patch23: 0023-fix-calling-set_client_capabilities.patch
Patch24: 0024-red_parse_qxl-fix-throwing-away-drawables-that-have-.patch
Patch25: 0025-red_worker.c-insert-a-drawable-to-its-position-in-th.patch
Patch26: 0026-red_worker.c-clearing-the-stream-vis_region-after-it.patch
Patch27: 0027-server-Fix-SpiceWorker-CRITICAL-red_worker.c-10968-r.patch
Patch28: 0028-worker_update_monitors_config-Drop-bogus-real_count-.patch
Patch29: 0029-red_worker.c-fix-not-destroying-streams-before-sendi.patch
Patch30: 0030-main_channel-add-routine-for-checking-if-a-network-t.patch
Patch31: 0031-red_worker-cleanup-add-is_low_bandwidth-flag-to-Comm.patch
Patch32: 0032-red_worker-fix-incorrect-is_low_bandwidth-after-migr.patch
Patch33: 0033-red_channel-add-spice_channel_client_error.patch
Patch34: 0034-red_channel-notify-and-shutdown-a-channel-client-whe.patch
Patch35: 0035-red_worker-fail-handle_migrate_data-instead-of-abort.patch
Patch36: 0036-server-red_worker-stride-0-is-tested-remove-abort.patch
Patch37: 0037-protect-against-error-during-red_channel_pipes_add_type.patch

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

ExclusiveArch:  x86_64

BuildRequires:  pkgconfig
BuildRequires:  gcc-c++
BuildRequires:  alsa-lib-devel
BuildRequires:  pixman-devel >= 0.18
BuildRequires:  libjpeg-turbo-devel
BuildRequires:  libXrandr-devel
BuildRequires:  libXext-devel
BuildRequires:  libXfixes-devel
BuildRequires:  openssl-devel
BuildRequires:  celt051-devel
BuildRequires:  libcacard-devel >= 0.1.2
# BuildRequires:  spice-protocol >= 0.10.1 -- not needed since spice-0.11.3
BuildRequires:  cyrus-sasl-devel
BuildRequires:  autoconf
BuildRequires:  automake
BuildRequires:  libtool

Requires:       pixman >= 0.18
Requires:       pkgconfig

%package devel
Summary:        Header files, libraries and development documentation for %{name}
Group:          Development/Libraries

Requires:       %{name} = %{version}-%{release}
Requires:       alsa-lib-devel
Requires:       pixman-devel >= 0.18
Requires:       libjpeg-turbo-devel
Requires:       openssl-devel
Requires:       celt051-devel
Requires:       spice-protocol >= 0.12.2


%description
The Simple Protocol for Independent Computing Environments (SPICE) is
a remote display system built for virtual environments which allows
you to view a computing 'desktop' environment not only on the machine
where it is running, but from anywhere on the Internet and from a wide
variety of machine architectures.

This package contains the runtime libraries for any application that wishes
to be a SPICE server.

%description devel
This package contains the header files, static libraries and development
documentation for %{name}. If you like to develop programs
using %{name}, you will need to install %{name}-devel.


%prep
%setup -q -n %{tarname}-%{version}
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1
%patch12 -p1
%patch13 -p1
%patch14 -p1
%patch15 -p1
%patch16 -p1
%patch17 -p1
%patch18 -p1
%patch19 -p1
%patch20 -p1
%patch21 -p1
%patch22 -p1
%patch23 -p1
%patch24 -p1
%patch25 -p1
%patch26 -p1
%patch27 -p1
%patch28 -p1
%patch29 -p1
%patch30 -p1
%patch31 -p1
%patch32 -p1
%patch33 -p1
%patch34 -p1
%patch35 -p1
%patch36 -p1
%patch37 -p1

# no point of calling git-version-gen for spice-common and also
# git-version-gen is missing in spice-common
sed -i 's,\[m4_esyscmd.build-aux/git-version-gen.*\],[%{version}],' spice-common/configure.ac

%build
pythonpath=$(dirname %{SOURCE100})
export PYTHONPATH=$pythonpath
autoreconf -fi
%configure --enable-smartcard --with-sasl
#sed -i 's|^hardcode_libdir_flag_spec=.*|hardcode_libdir_flag_spec=""|g' libtool
#sed -i 's|^runpath_var=LD_RUN_PATH|runpath_var=DIE_RPATH_DIE|g' libtool
make -C spice-common/common %{?_smp_mflags}
make -C server %{?_smp_mflags}


%install
rm -rf $RPM_BUILD_ROOT
make -C server install DESTDIR=$RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/%{_libdir}/pkgconfig
install -m 00644 %{name}.pc $RPM_BUILD_ROOT/%{_libdir}/pkgconfig


%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig


%clean
rm -rf $RPM_BUILD_ROOT


%files
%defattr(-, root, root, 0755)
%doc COPYING README
%{_libdir}/libspice-server.so.*

%files devel
%defattr(-, root, root, 0755)
%doc COPYING README
%{_includedir}/spice-server/
%{_libdir}/libspice-server.so
%{_libdir}/pkgconfig/spice-server.pc
%exclude %{_libdir}/*.a
%exclude %{_libdir}/*.la


%changelog
* Wed Aug 28 2013 Jonathon Jongsma <jjongsma@redhat.com> - 0.12.0-12.el6_4.3
- Fixes an abort on unsafe client ring access
  Resolves: rhbz#986298

* Thu Jun 20 2013 Uri Lublin <uril@redhat.com> - 0.12.0-12.el6_4.2
- Fix a crash running a F19 guest -- do not abort on stride > 0
  Resolves: rhbz#973703

* Wed May 9 2013 Yonit Halperin <yhalperi@redhat.com> - 0.12.0-12.el6_4.1
- Migration related fixes
  * Destroy video streams before sending MSG_MIGRATE
  * Fix wrong is_low_bandwidth setting after 2 migrations of a session
    that was originally a low bandwidth one.
  Resolves: rhbz#956984
  Resolves: rhbz#961427

* Wed Jan 16 2013 Hans de Goede <hdegoede@redhat.com> - 0.12.0-12
- Fix a crash when rapidly changing monitor configuration
  Resolves: rhbz#868807

* Wed Jan 09 2013 Uri Lublin <uril@redhat.com> 0.12.0-11
- Fix a crash when setting screen-saver properties.
- Fix a leak.
  Resolves: rhbz#891326

* Thu Dec 20 2012 Yonit Halperin <yhalperi@redhat.com> 0.12.0-10
- Fix throwing away drawables that have masks
  Resolves: rhbz#864982

* Mon Dec 17 2012 Uri Lublin <uril@redhat.com> 0.12.0-9
- Fix calling set_client_capabilities when it is unsupported by qemu
  (fixes a crash when qemu-kvm is started with spice but without qxl)
  Resolves: rhbz#880276

* Fri Dec 7 2012 Yonit Halperin <yhalperi@redhat.com> 0.12.0-8
- Fix crash when reconnecting while a video is played
  Resolves: rhbz#883564

* Mon Dec 3 2012 Yonit Halperin <yhalperi@redhat.com> 0.12.0-7
- Fix mishandling of agent data received from the client after agent disconnection
  Resolves: rhbz#881980

* Thu Nov 29 2012 Yonit Halperin <yhalperi@redhat.com> 0.12.0-6
- Fix sending internal images with stride > bpp*width to lz compression
  Resolves: rhbz#876685

* Mon Nov 26 2012 Yonit Halperin <yhalperi@redhat.com> 0.12.0-5
- Fix various migration related bugs
  * don't process both cmd ring and dispatcher queue till migration data is received
  * fix assigning bad memory references to marshaller
  * fix memory corruption when receiving display migration data that exceeds 1024 bytes
  Resolves: rhbz#866929
  Resolves: rhbz#862352
  Resolves: rhbz#878700

* Wed Nov 21 2012 Uri Lublin <uril@redhat.com> 0.12.0-4
- Build/Requires libjpeg-turbo-devel instead of libjpeg-devel
- Related: rhbz#788687

* Thu Nov 15 2012 Alon Levy <alevy@redhat.com> 0.12.0-3
- don't call set_client_capabilities if vm is stopped.
- Resolves: rhbz#867405

* Mon Oct 29 2012 Uri Lublin <uril@redhat.com> 0.12.0-2
- Make spice-server-devel package Require spice-protocol >= 0.12.2
- Related: rhbz#842353

* Thu Sep 20 2012 Uri Lublin <uril@redhat.com> 0.12.0-1
- Rebase to upstream spice-server 0.12.0, which adds:
  * support setting client monitor configuration via device
    QXLInterface::client_monitors_config
  * support notifying guest of client capabilities
    QXLInterface::set_client_capabilities
  * new capability for A8 Surface support
  Resolves: rhbz#836123
  Resolves: rhbz#842353
  Resolves: rhbz#842310
- Report and return on failure to initialize ssl (Patches 1-7)

* Mon Sep 03 2012 Uri Lublin <uril@redhat.com> 0.11.3-1
- Rebase to upstream spice-server 0.11.3, which adds:
  * Support for seamless migration
  * Support for Render
  * spice-protocol is in the tarball now (a submodule in git)
  Resolves: rhbz#836123
  Resolves: rhbz#842353

* Sun May 20 2012 Yonit Halperin <yhalperi@redhat.com> 0.10.1-10
- Fix crash in video streaming
  Resolves: rhbz#822686

* Wed May 16 2012 Yonit Halperin <yhalperi@redhat.com> 0.10.1-9
- Fix memory leak during video streaming
  Resolves rhbz#821334
- Fix segfault introduced when fixing rhbz#813826
  Related: rhbz#813826

* Tue May 15 2012 Alon Levy <alevy@redhat.com> - 0.10.1-8
- Fix self_bitmap lifetime to that of RedDrawable
  Resolves rhbz#821235

* Tue May 8 2012 Alon Levy <alevy@redhat.com> - 0.10.1-7
- Add usbredir to list of channels for security purposes
  Resolves rhbz#819484

* Mon May 07 2012 Yonit Halperin <yhalperi@redhat.com> - 0.10.1-6
  - Fix glitches in youtube movies
    + support video streams with frames of different sizes
  Resolves: rhbz#813826

* Thu Apr 05 2012 Hans de Goede <hdegoede@redhat.com> - 0.10.1-5
- Don't free the rcc twice when unregistering an usbredir chardev
  Resolves: rhbz#806169

* Mon Mar 05 2012 Christophe Fergeau <cfergeau@redhat.com> - 0.10.1-4
- add more logging for expired/invalid tickets
  Resolves: rhbz#787669
- add more logging about use of certificates
  Resolves: rhbz#787678

* Thu Feb 23 2012 alon <alevy@redhat.com> - 0.10.1-3
- fix race that can lead to accessing freed memory
Resolves: rhbz#790749

* Wed Feb 22 2012 Yonit Halperin <yhalperi@redhat.com> - 0.10.1-2
- support IPV6 addresses in channel events sent to qemu
Resolves: rhbz#788444

* Mon Jan 23 2012 Hans de Goede <hdegoede@redhat.com> - 0.10.1-1
- Rebase to upstream 0.10.1
Resolves: rhbz#758089
- This release adds support for usbredirection
Resolves: rhbz#758091
- This release fixes a bug in smartcard error handling
Resolves: rhbz#741259

* Wed Oct 26 2011 Alon Levy <alevy@redhat.com> - 0.8.2-5
- main dispatcher added
Resolves: rhbz#746950

* Wed Sep 28 2011 Uri Lublin <uril@redhat.com> - 0.8.2-4
- semi-seamless migration support
- added pyparsing.py as source, and using it to build the package.
- client patches are not applied.
- requires spice-protocol-0.8.1-2 (equivalent to upstream 0.8.2)
- advertise itself as version 0.8.3, to notify the new feature.
Resolves: rhbz#738266

* Mon Aug 01 2011 Uri Lublin <uril@redhat.com> - 0.8.2-3
- Drop unnecessary X11 and alsa requires from spice-server.pc
  + Fix a rpmdiff warning
Related: rhbz#723676
- server/red_dispatcher: fix wrong resolution set for tablet
Resolves: rhbz#726973

* Wed Jul 28 2011 Uri Lublin <uril@redhat.com> - 0.8.2-2
- On migration, do not read command rings before RED_WORKER_MESSAGE_START
Resolves: rhbz#718713

* Fri Jul 22 2011 Uri Lublin <uril@redhat.com> - 0.8.2-1
- Rebase to upstream 0.8.2, including
 + sasl support (fdo bz 34795)
 + support guest async io
 + support guest suspend and hibernate
 + add symbol versioning to libspice-server.so
 + prevent running an old spice-server with a newer qemu
 + Bug fixes (RHBZ): 714801, 713474, 674532, 653545
 + BuildRequires spice-protocol >= 0.8.1 and cyrus-sasl-devel
Resolves: #723676

* Mon Jun 27 2011 Uri Lublin <uril@redhat.com> - 0.8.1-2
- Remove Obsolete lines (added in 0.7.2-3)
Resolves: #707119

* Mon Jun 05 2011 Uri Lublin <uril@redhat.com> - 0.8.1-1
- Rebase to upstream 0.8.1, including
 + Make copy/paste support configurable
 + Some server/vdagent bugs fixed
Resolves: #710200

* Mon Mar 07 2011 Uri Lublin <uril@redhat.com> - 0.8.0-1
- Rebase to upstream 0.8.0
  + Includes "Fix segfault on migration" patch
  + Some spice-client bug fixes.
Resolves: #672035

* Mon Feb 21 2011 Uri Lublin <uril@redhat.com> - 0.7.3-2
- Fix segfault on migration
Resolves: #674451

* Thu Feb 17 2011 Uri Lublin <uril@redhat.com> - 0.7.3-1
- Rebase to upstream 0.7.3:
  + Mostly smart-card updates:
    - including all the changes in 0.7.2.4
  + Some gcc warning cleanups.
- Fix permissions of spice-server.pc
Resolves: #672035

* Fri Feb 04 2011 Uri Lublin <uril@redhat.com> - 0.7.2-4
- smartcard -- libcacard 0.1.2 updates:
 - server
  - use network byte order when talking to device.
 - both
  - no more reader_id_t, uint32_t instead
  - no more ReaderAddResponse, use VSC_Error with
    code==VSC_SUCCESS instead.
  - change an assert to a red_printf("error:..")
    if got an unexpectedly undefined reader id.
 - client (not part of this package)
  - track number of expected reader insertions
Resolves: #674937

* Fri Feb 04 2011 Uri Lublin <uril@redhat.com> - 0.7.2-3
- Obsolete old packages that are not needed now
Resolves: #674171

* Mon Jan 24 2011 Uri Lublin <uril@redhat.com> - 0.7.2-2
- Rebase to spice upstream release 0.7.2
- Drop all patches (all upstreamed)
- Enable smartcard (CAC) support
Resolves: #672035

* Fri Jul 30 2010 Uri Lublin <uril@redhat.com> - 0.4.2-15
 - Fix unsafe accesses
  + fix unsafe guest data accessing.
  + fix unsafe free() call.
  + fix unsafe cursor items handling.
  + add missing overflow check.
Resolves: #568811

* Wed Jun 30 2010 Uri Lublin <uril@redhat.com> - 0.4.2-14
- make opengl optional - add a missing patch
  ifdef out some opengl calls.
Resolves: #482556

* Wed Jun 30 2010 Uri Lublin <uril@redhat.com> - 0.4.2-13
- remove Requires and BuildRequires mesa-libGLU-devel
  + open-gl is now disabled.
- bumped release to -13 due to tag issue
Related: #482556

* Wed Jun 30 2010 Uri Lublin <uril@redhat.com> - 0.4.2-11
- make opengl optional, disabled by default (2 patches)
Resolves: #482556

* Thu Apr 22 2010 Uri Lublin <uril@redhat.com> - 0.4.2-10
- spice: server: new-api (4 more patches)
     + streaming-video, agent-mouse, playback-compression.
Related: #571286

* Sun Apr  4 2010 Uri Lublin <uril@redhat.com> - 0.4.2-9
 - generate auto* generated files (e.g. Makefile.in)
Resolves: #579329

* Tue Mar 23 2010 Uri Lublin <uril@redhat.com> - 0.4.2-8
 - spice server: renaming library and includedir
Resolves: #573349

* Tue Mar 23 2010 Uri Lublin <uril@redhat.com> - 0.4.2-7
 - fix wrong access to ring item
Resolves: #575556

* Tue Mar 23 2010 Uri Lublin <uril@redhat.com> - 0.4.2-6
 - more permissive video identification
Resolves: #575576

* Tue Mar 23 2010 Uri Lublin <uril@redhat.com> - 0.4.2-5
 - new migration process
Resolves: #576029

* Wed Mar 17 2010 Uri Lublin <uril@redhat.com> - 0.4.2-4
- spice: server: new-api (2 more patches)
Related: #571286

* Mon Mar  7 2010 Uri Lublin <uril@redhat.com> - 0.4.2-3
 - Use default configure macro (remove _prefix and _libdir)
Related: #543948

* Sun Mar 07 2010 Uri Lublin <uril@redhat.com> - 0.4.2-2
- spice: server: new-api (10 patches)
Related: #571286

* Sun Mar 07 2010 Uri Lublin <uril@redhat.com> - 0.4.2-1
- spice: server: avoid video streaming of small images
Resolves: #571283

* Mon Jan 11 2009 Uri Lublin <uril@redhat.com> - 0.4.2-0
 - first spec for 0.4.2
Related: #549807
